#include <stdio.h>

struct Image 
{  
  unsigned long int Width;     // Width of the image
  unsigned long int Height;    // Height of the image
  unsigned char Nbpp;          // Number of bits by pixel (Generaly 1,4,8 or 24)
};


/* en considérant que la structure AutreStructure est définie */



// Read a BMP file
// return -1 if the signature is not a bmp file
// return -2 if the size of the file is not in accordance with the real size
// return -3 if a reserved byte is not equal to 0
// return -4 if the size of header structure is not equal to 40
// return -5 if the number of plane is not equal to 1
// return -6 if the number of bit by pixel is not standard (1,4,8 or 24)
// return -7 if the file is compressed

int ReadBMPFile(const char * filename,struct Image *pImg)
{
  char signature[2];
  unsigned char ch;
  char Nbits;
  unsigned long int size=0;  
  unsigned long int fsize=0;  
  unsigned long int Offset=0; 
  unsigned long int width=0; 
  unsigned long int height=0; 
  unsigned long int SizeData=0;   
  unsigned long int HorResolution=0;
  unsigned long int VerResolution=0;
  unsigned long int NumberOfColor=0;
  unsigned long int NumberOfImColor=0;

  FILE *file = fopen(filename,"r");

  // Obtain file size.
  fseek (file , 0 , SEEK_END);
  fsize = ftell (file);
  rewind (file);

  // Read signature (Offset=0 Size=2) and check it is equal to "BM"
  signature[0]=fgetc(file);
  signature[1]=fgetc(file);
  if ((signature[0]!='B') || (signature[1]!='M')) return (-1);

  // Read size of file (Offset=2 Size=4) and check if it's equal to the real file size
  size+=fgetc(file);
  size+=fgetc(file)<<8;
  size+=fgetc(file)<<16;
  size+=fgetc(file)<<24;
  if (size!=fsize) return (-2);

  // Read reserved byte (Offset=6 Size=4) and check if it's equal to 0
  if (fgetc(file)!=0) return (-3);  
  if (fgetc(file)!=0) return (-3);  
  if (fgetc(file)!=0) return (-3);  
  if (fgetc(file)!=0) return (-3);

  // Read the offset (Offset=10 Size=4)
  Offset+=fgetc(file);
  Offset+=fgetc(file)<<8;
  Offset+=fgetc(file)<<16;
  Offset+=fgetc(file)<<24;

  // Read the offset (Offset=14 Size=4) and check if it's equal to 40
  if (fgetc(file)!=40) return (-4);  
  if (fgetc(file)!=0) return (-4);  
  if (fgetc(file)!=0) return (-4);  
  if (fgetc(file)!=0) return (-4);

  // Read the image width (Offset=18 Size=4)
  width+=fgetc(file);
  width+=fgetc(file)<<8;
  width+=fgetc(file)<<16;
  width+=fgetc(file)<<24;

  // Read the image height (Offset=22 Size=4)
  height+=fgetc(file);
  height+=fgetc(file)<<8;
  height+=fgetc(file)<<16;
  height+=fgetc(file)<<24;

  // Read the number of plane (Offset=26 Size=2) and check if it's equal to 1
  if (fgetc(file)!=1) return (-5);  
  if (fgetc(file)!=0) return (-5); 

  // Read the number of bit by pixel (Offset=28 Size=2) and check if it's a valid value
  Nbits=fgetc(file);
  if (fgetc(file)!=0) return (-6); 
  if ((Nbits!=1) && (Nbits!=4) && (Nbits!=8) && (Nbits!=24)) return (-6);

  // Read the compression type (Offset=30 Size=4) and check if it's a supported type
  if (fgetc(file)!=0) return (-7);  
  if (fgetc(file)!=0) return (-7);
  if (fgetc(file)!=0) return (-7);  
  if (fgetc(file)!=0) return (-7);

  // Read the size of the image data (Offset=34 Size=4)
  SizeData+=fgetc(file);
  SizeData+=fgetc(file)<<8;
  SizeData+=fgetc(file)<<16;
  SizeData+=fgetc(file)<<24;

  // Read the horizontal resolution of the image data (Offset=38 Size=4)
  HorResolution+=fgetc(file);
  HorResolution+=fgetc(file)<<8;
  HorResolution+=fgetc(file)<<16;
  HorResolution+=fgetc(file)<<24;

  // Read the vertical resolution of the image data (Offset=42 Size=4)
  VerResolution+=fgetc(file);
  VerResolution+=fgetc(file)<<8;
  VerResolution+=fgetc(file)<<16;
  VerResolution+=fgetc(file)<<24;

  // Read the number of colour in the image (Offset=46 Size=4)

  NumberOfColor+=fgetc(file);
  NumberOfColor+=fgetc(file)<<8;
  NumberOfColor+=fgetc(file)<<16;
  NumberOfColor+=fgetc(file)<<24;

  // Read the number of important colour in the image (Offset=50 Size=4)

  NumberOfImColor+=fgetc(file);
  NumberOfImColor+=fgetc(file)<<8;
  NumberOfImColor+=fgetc(file)<<16;
  NumberOfImColor+=fgetc(file)<<24;
 

  printf (" Signature : \t\t\t%c%c\n",signature[0],signature[1]); */
  printf (" Size of the file: \t\t%d bytes\n",size); */
  printf (" Offset of the data: \t\t%d bytes\n",Offset);   */
  printf (" Width of the image: \t\t%d pixels\n",width);   */
  printf (" Height of the image: \t\t%d pixels\n",height);  */
  printf (" Number of bits by pixel : \t%d bits\n",Nbits); */
  printf (" Size of image data : \t\t%d bits\n",SizeData); */
  printf (" Horizontal resolution : \t%d ppm\n",HorResolution);  */
  printf (" Vertical resolution : \t\t%d ppm\n",VerResolution);    */
  printf (" Number of colors : \t\t%d color(s)\n",NumberOfColor); */
  printf (" Number of important colors : \t%d color(s)\n",NumberOfImColor); */

  pImg->Width=width;
  pImg->Height=height;
  pImg->Nbpp=Nbits;
  return (0);
}




int main()
{
  struct Image im1;

  printf ("%d\n",ReadBMPFile("image1.bmp",&im1));
  printf ("%d\n",im1.Width);  
  printf ("%d\n",im1.Height);
  return (0);
}
